diff -ruN --exclude=CVS ../ice.orig/Makefile ./Makefile
--- ../ice.orig/Makefile	2013-04-27 10:50:46.000000000 +0200
+++ ./Makefile	2013-06-02 14:20:04.000000000 +0200
@@ -2,14 +2,15 @@
 # $FreeBSD: devel/ice/Makefile 316654 2013-04-27 08:50:46Z mva $
 
 PORTNAME=		Ice
-PORTVERSION=		3.4.2
-PORTREVISION=		3
+PORTVERSION=		3.5.0
 CATEGORIES=		devel
-MASTER_SITES=		http://download.zeroc.com/Ice/3.4/
+MASTER_SITES=		http://download.zeroc.com/Ice/3.5/
 
 MAINTAINER=		freebsd@grem.de
 COMMENT=		Modern alternative to object middleware such as CORBA/COM/DCOM/COM+
 
+LICENSE=		GPLv2
+
 LIB_DEPENDS=		expat:${PORTSDIR}/textproc/expat2 \
 			mcpp:${PORTSDIR}/devel/mcpp
 
@@ -26,8 +27,8 @@
 
 USE_GMAKE=		yes
 USES=			iconv
-USE_BDB=		42+
-INVALID_BDB_VER=	2 3 40 41
+USE_BDB=		5
+INVALID_BDB_VER=	2 3 40 41 42 43 44 46 47 48
 USE_LDCONFIG=		yes
 BUILD_WRKSRC=		${WRKSRC}/cpp
 INSTALL_WRKSRC=		${WRKSRC}/cpp
diff -ruN --exclude=CVS ../ice.orig/distinfo ./distinfo
--- ../ice.orig/distinfo	2012-07-14 15:54:48.000000000 +0200
+++ ./distinfo	2013-05-19 23:35:43.000000000 +0200
@@ -1,2 +1,2 @@
-SHA256 (Ice-3.4.2.tar.gz) = dcf0484495b6df0849ec90a00e8204fe5fe1c0d3882bb438bf2c1d062f15c979
-SIZE (Ice-3.4.2.tar.gz) = 5485106
+SHA256 (Ice-3.5.0.tar.gz) = 583d4a819d50ad8b79b1e9ad45abfa3078f981486271ca8cd9ede8fa420ff575
+SIZE (Ice-3.5.0.tar.gz) = 5388847
diff -ruN --exclude=CVS ../ice.orig/files/patch-config-Make.common.rules ./files/patch-config-Make.common.rules
--- ../ice.orig/files/patch-config-Make.common.rules	1970-01-01 01:00:00.000000000 +0100
+++ ./files/patch-config-Make.common.rules	2013-06-01 19:52:09.000000000 +0200
@@ -0,0 +1,18 @@
+--- config.orig/Make.common.rules	2013-05-20 22:21:58.666286011 +0000
++++ config/Make.common.rules	2013-05-20 22:20:50.897196090 +0000
+@@ -378,11 +378,15 @@
+ 	then \
+ 	    echo "Creating $(install_slicedir)..." ; \
+ 	    $(call mkdir, $(install_slicedir)) ; \
++	fi
++
++	@if test -d $(install_slicedir) ; \
++	then \
+ 	    cd $(top_srcdir)/../slice ; \
+ 	    for subdir in * ; \
+ 	    do \
+ 	        echo "Copying slice/$$subdir to $(install_slicedir)..." ; \
+ 	        cp -fpr $$subdir $(install_slicedir) ; \
+ 	    done ; \
+-	    fi
++	fi
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-Makefile ./files/patch-cpp-Makefile
--- ../ice.orig/files/patch-cpp-Makefile	1970-01-01 01:00:00.000000000 +0100
+++ ./files/patch-cpp-Makefile	2013-05-20 01:05:19.000000000 +0200
@@ -0,0 +1,26 @@
+--- cpp.orig/Makefile	2013-03-11 15:19:46.000000000 +0000
++++ cpp/Makefile	2013-05-19 22:06:57.713280491 +0000
+@@ -11,11 +11,22 @@
+ 
+ include $(top_srcdir)/config/Make.rules
+ 
+-SUBDIRS		= config src include test
++SUBDIRS		= config src include
++
++ifeq ($(NOTESTS),)
++SUBDIRS		:= $(SUBDIRS) test
++endif
+ 
+ ifeq ($(shell uname | grep MINGW),)
++ifeq ($(NODEMOS),)
+ SUBDIRS		:= $(SUBDIRS) demo
+ endif
++endif
++
++ifeq ($(NOPORTDOCS),)
++SUBDIRS		:= $(SUBDIRS) doc
++endif
++
+ 
+ INSTALL_SUBDIRS	= $(install_bindir) $(install_libdir) $(install_includedir) $(install_configdir)
+ 
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-allTests.py ./files/patch-cpp-allTests.py
--- ../ice.orig/files/patch-cpp-allTests.py	2012-07-14 15:54:48.000000000 +0200
+++ ./files/patch-cpp-allTests.py	2013-05-20 00:26:42.000000000 +0200
@@ -1,13 +1,5 @@
---- cpp.orig/allTests.py	2011-06-15 21:43:58.000000000 +0200
-+++ cpp/allTests.py	2012-03-04 20:14:52.000000000 +0100
-@@ -25,6 +25,7 @@
- # List of all basic tests.
- #
- tests = [ 
-+
-     ("IceUtil/condvar", ["once", "win32only"]),
-     ("IceUtil/thread",  ["once"]),
-     ("IceUtil/unicode", ["once"]),
+--- cpp.orig/allTests.py	2013-03-11 15:19:58.000000000 +0000
++++ cpp/allTests.py	2013-05-19 22:25:00.000000000 +0000
 @@ -62,7 +63,7 @@
      ("Ice/servantLocator", ["core"]),
      ("Ice/interceptor", ["core"]),
@@ -22,9 +14,9 @@
  if TestUtil.isWin32() or os.getuid() == 0:
      tests += [
 -        ("IceUtil/priority", ["core", "nodarwin"]),
--        ("Ice/threadPoolPriority", ["core", "nodarwin"])
+-        ("Ice/threadPoolPriority", ["core", "nodarwin", "nomx"])
 +        ("IceUtil/priority", ["core", "nodarwin", "nofreebsd"]),
-+        ("Ice/threadPoolPriority", ["core", "nodarwin", "nofreebsd"])
++        ("Ice/threadPoolPriority", ["core", "nodarwin", "nofreebsd", "nomx"])
          ]
  
  if __name__ == "__main__":
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-config-Make.rules ./files/patch-cpp-config-Make.rules
--- ../ice.orig/files/patch-cpp-config-Make.rules	1970-01-01 01:00:00.000000000 +0100
+++ ./files/patch-cpp-config-Make.rules	2013-05-21 02:45:50.000000000 +0200
@@ -0,0 +1,13 @@
+--- cpp.orig/config/Make.rules	Fri Mar 11 16:19:00 2013
++++ cpp/config/Make.rules	Fri May 19 22:00:09 2013
+@@ -233,7 +233,9 @@
+           DB_FLAGS          = -I/usr/local/include/db53
+           DB_LIBS           = -L/usr/local/$(libsubdir)/db53 -ldb_cxx
+       else
+-        DB_LIBS      = -ldb_cxx
++        DB_FLAGS          = -I%%BDB_INCLUDE_DIR%%
++        DB_LIBS           = -L%%BDB_LIB_DIR%% -l%%BDB_LIB_CXX_NAME%%
++        DB_RPATH_LINK     = $(call rpathlink,%%BDB_LIB_DIR%%)
+       endif
+    endif
+ endif
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-include-IceUtil-Config.h ./files/patch-cpp-include-IceUtil-Config.h
--- ../ice.orig/files/patch-cpp-include-IceUtil-Config.h	2012-09-23 16:45:33.000000000 +0200
+++ ./files/patch-cpp-include-IceUtil-Config.h	2013-05-20 04:19:22.000000000 +0200
@@ -1,19 +1,11 @@
---- cpp.orig/include/IceUtil/Config.h	2011-06-15 21:43:58.000000000 +0200
-+++ cpp/include/IceUtil/Config.h	2012-09-10 11:43:58.000000000 +0200
-@@ -248,3 +248,16 @@ public:
- #define ICE_DEFAULT_MUTEX_PROTOCOL PrioNone
- 
+--- cpp.orig/include/IceUtil/Config.h	2013-03-11 15:19:46.000000000 +0000
++++ cpp/include/IceUtil/Config.h	2013-05-20 02:09:58.239194578 +0000
+@@ -51,7 +51,7 @@
+ // Check for C++ 11 support
+ //
+ #if (defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 5)) && defined(__GXX_EXPERIMENTAL_CXX0X__)) || \
+-    (defined(__clang__) && (__clang_major__ >= 4) && __cplusplus >= 201103) || \
++    (defined(__clang__) && ((defined(__APPLE__) && __clang_major__ >= 4) || (!defined(__APPLE__) && __clang_major__ >= 3)) && __cplusplus >= 201103) || \
+     (defined(_MSC_VER) && (_MSC_VER >= 1600))
+ #   define ICE_CPP11
  #endif
-+
-+
-+//
-+// Macro used for declaring destructors that might throw - required for C++11
-+//
-+#if __cplusplus >= 201103L
-+#define ICE_DESTRUCTORS_DONT_THROW_BY_DEFAULT
-+#define ICE_NOEXCEPT_FALSE noexcept(false)
-+#define ICE_NOEXCEPT_TRUE noexcept(true)
-+#else
-+#define ICE_NOEXCEPT_FALSE
-+#define ICE_NOEXCEPT_TRUE
-+#endif
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-src-Ice-Network.cpp ./files/patch-cpp-src-Ice-Network.cpp
--- ../ice.orig/files/patch-cpp-src-Ice-Network.cpp	2012-09-23 16:45:33.000000000 +0200
+++ ./files/patch-cpp-src-Ice-Network.cpp	2013-05-20 00:56:41.000000000 +0200
@@ -1,6 +1,6 @@
---- cpp.orig/src/Ice/Network.cpp	2011-06-15 21:43:58.000000000 +0200
-+++ cpp/src/Ice/Network.cpp	2012-09-10 11:43:58.000000000 +0200
-@@ -715,7 +715,11 @@
+--- cpp.orig/src/Ice/Network.cpp	2013-03-11 15:19:46.000000000 +0000
++++ cpp/src/Ice/Network.cpp	2013-05-19 22:55:40.257195813 +0000
+@@ -936,7 +936,11 @@
      WSASetLastError(error);
  #else
      int error = errno;
@@ -13,12 +13,3 @@
      {
          SocketException ex(__FILE__, __LINE__);
          ex.error = getSocketErrno();
-@@ -1098,7 +1098,7 @@ IceInternal::doBind(SOCKET fd, const struct sockaddr_storage& addr)
-         size = 0; // Keep the compiler happy.
-     }
- 
--    if(bind(fd, reinterpret_cast<const struct sockaddr*>(&addr), size) == SOCKET_ERROR)
-+    if(::bind(fd, reinterpret_cast<const struct sockaddr*>(&addr), size) == SOCKET_ERROR)
-     {
-         closeSocketNoThrow(fd);
-         SocketException ex(__FILE__, __LINE__);
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-src-IceGrid-FileCache.cpp ./files/patch-cpp-src-IceGrid-FileCache.cpp
--- ../ice.orig/files/patch-cpp-src-IceGrid-FileCache.cpp	2012-09-23 16:45:33.000000000 +0200
+++ ./files/patch-cpp-src-IceGrid-FileCache.cpp	2013-06-01 19:51:46.000000000 +0200
@@ -1,20 +1,16 @@
---- cpp.orig/src/IceGrid/FileCache.cpp	2011-06-15 21:43:58.000000000 +0200
-+++ cpp/src/IceGrid/FileCache.cpp	2012-09-10 11:43:58.000000000 +0200
-@@ -195,15 +195,12 @@ FileCache::read(const string& file, Ice::Long offset, int size, Ice::Long& newOf
- 
-         totalSize += lineSize;
-         lines.push_back(line);
--#if defined(_MSC_VER) && (_MSC_VER < 1300)
+--- cpp.orig/src/IceGrid/FileCache.cpp	2013-03-11 15:19:12.271195149 +0000
++++ cpp/src/IceGrid/FileCache.cpp	2013-06-01 17:47:48.636196265 +0000
+@@ -195,11 +195,11 @@
+         // Some eofbit cases will also set failbit. So first
+         // check eof.
+         //
 -        if(is.eof())
-+        
 +        if(is.eof() || is.fail())
          {
              newOffset += line.size();
          }
-         else
--#else
--        if(!is.fail())
--#endif
+-        else if(!is.fail())
++        else
          {
              newOffset = is.tellg();
          }
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-src-slice2cpp-Gen.cpp ./files/patch-cpp-src-slice2cpp-Gen.cpp
--- ../ice.orig/files/patch-cpp-src-slice2cpp-Gen.cpp	2012-07-14 15:54:48.000000000 +0200
+++ ./files/patch-cpp-src-slice2cpp-Gen.cpp	2013-05-21 02:46:05.000000000 +0200
@@ -1,111 +1,13 @@
---- cpp.orig/src/slice2cpp/Gen.cpp	2011-06-15 21:43:59.000000000 +0200
-+++ cpp/src/slice2cpp/Gen.cpp	2012-03-04 20:14:53.000000000 +0100
-@@ -1944,8 +1944,10 @@
+--- cpp.orig/src/slice2cpp/Gen.cpp	2013-03-11 15:19:46.000000000 +0000
++++ cpp/src/slice2cpp/Gen.cpp	2013-05-20 19:51:48.109197053 +0000
+@@ -385,6 +385,10 @@
+         H << "\n#include <Ice/Proxy.h>";
+         H << "\n#include <Ice/OutgoingAsync.h>";
      }
- 
-     string name = fixKwd(p->name());
-+    string scoped = fixKwd(p->scoped());
- 
-     H << sp << nl << "class " << name << ';';
-+    H << nl << _dllExport << "::IceProxy::Ice::Object* upCast(::IceProxy" << scoped << "*);";
- }
- 
- Slice::Gen::ProxyVisitor::ProxyVisitor(Output& h, Output& c, const string& dllExport) :
-@@ -3691,10 +3693,22 @@
- Slice::Gen::ObjectDeclVisitor::visitClassDecl(const ClassDeclPtr& p)
- {
-     string name = fixKwd(p->name());
-+    string scoped = fixKwd(p->scoped());
- 
-     H << sp << nl << "class " << name << ';';
-     H << nl << "bool operator==(const " << name << "&, const " << name << "&);";
-     H << nl << "bool operator<(const " << name << "&, const " << name << "&);";
-+
-+    H << sp;
-+
-+    if(!p->isLocal())
++    else if(p->hasNonLocalClassDecls())
 +    {
-+        H << nl << _dllExport << "::Ice::Object* upCast(" << scoped << "*);";
++        H << "\n#include <Ice/Proxy.h>";
 +    }
-+    else
-+    {
-+        H << nl << _dllExport << "::Ice::LocalObject* upCast(" << scoped << "*);";
-+    }
- }
- 
- void
-@@ -4922,13 +4936,13 @@
- {
-     if((BuiltinPtr::dynamicCast(p) && BuiltinPtr::dynamicCast(p)->kind() == Builtin::KindObject)
-        || ClassDeclPtr::dynamicCast(p))
--    {
--        C << nl << "if(" << prefix << name << ')';
-+    {        C << nl << "if(" << prefix << name << ')';
-         C << sb;
-         ClassDeclPtr decl = ClassDeclPtr::dynamicCast(p);
-         if(decl)
-         {
--            C << nl << "::IceInternal::upCast(" << prefix << name << ".get())->__addObject(_c);";
-+            string scope = fixKwd(decl->scope());
-+            C << nl << scope << "upCast(" << prefix << name << ".get())->__addObject(_c);";
-         }
-         else
-         {
-@@ -4991,9 +5005,10 @@
-         ClassDeclPtr decl = ClassDeclPtr::dynamicCast(p);
-         if(decl)
-         {
--            C << nl << "if(" << "::IceInternal::upCast(" << prefix << name << ".get())->__usesClasses())";
-+            string scope = fixKwd(decl->scope());
-+            C << nl << "if(" << scope << "upCast(" << prefix << name << ".get())->__usesClasses())";
-             C << sb;
--            C << nl << "::IceInternal::upCast(" << prefix << name << ".get())->__decRefUnsafe();";
-+            C << nl << scope << "upCast(" << prefix << name << ".get())->__decRefUnsafe();";
-             C << nl << prefix << name << ".__clearHandleUnsafe();";
  
-         }
-@@ -5629,40 +5644,30 @@
- {
-     string scoped = fixKwd(p->scoped());
- 
--    H << sp;
--
--    if(!p->isLocal())
--    {
--        H << nl << _dllExport << "::Ice::Object* upCast(" << scoped << "*);";
--        H << nl << _dllExport << "::IceProxy::Ice::Object* upCast(::IceProxy" << scoped << "*);";
--    }
--    else
--    {
--        H << nl << _dllExport << "::Ice::LocalObject* upCast(" << scoped << "*);";
--    }
- }
- 
- bool
- Slice::Gen::IceInternalVisitor::visitClassDefStart(const ClassDefPtr& p)
- {
-     string scoped = fixKwd(p->scoped());
-+    string scope = fixKwd(p->scope());
- 
-     C << sp;
-     if(!p->isLocal())
+     if(p->hasNonLocalDataOnlyClasses() || p->hasNonLocalExceptions())
      {
-         C << nl
- 	  << (_dllExport.empty() ? "" : "ICE_DECLSPEC_EXPORT ")
--	  << "::Ice::Object* IceInternal::upCast(" << scoped << "* p) { return p; }";
-+	  << "::Ice::Object* " << scope << "upCast(" << scoped << "* p) { return p; }";
-         C << nl
- 	  << (_dllExport.empty() ? "" : "ICE_DECLSPEC_EXPORT ")
--	  << "::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy" << scoped
-+	  << "::IceProxy::Ice::Object* IceProxy" << scope << "upCast(::IceProxy" << scoped
-           << "* p) { return p; }";
-     }
-     else
-     {
-         C << nl
- 	  << (_dllExport.empty() ? "" : "ICE_DECLSPEC_EXPORT ")
--	  << "::Ice::LocalObject* IceInternal::upCast(" << scoped << "* p) { return p; }";
-+	  << "::Ice::LocalObject* " << scope << "upCast(" << scoped << "* p) { return p; }";
-     }
- 
-     return true;
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-test-Glacier2-ssl-Server.cpp ./files/patch-cpp-test-Glacier2-ssl-Server.cpp
--- ../ice.orig/files/patch-cpp-test-Glacier2-ssl-Server.cpp	2012-07-14 15:54:48.000000000 +0200
+++ ./files/patch-cpp-test-Glacier2-ssl-Server.cpp	2013-05-20 01:06:16.000000000 +0200
@@ -18,15 +18,6 @@
  }
  
  }
-@@ -99,7 +105,7 @@
-     }
- 
-     virtual void
--    ice_ping(const Ice::Current& current)
-+    ice_ping(const Ice::Current& current) const
-     {
-         testContext(_ssl, current.ctx);
-     }
 @@ -133,8 +139,11 @@
      {
          testContext(true, current.ctx);
diff -ruN --exclude=CVS ../ice.orig/files/patch-cpp-test-Ice-metrics-AllTests.cpp ./files/patch-cpp-test-Ice-metrics-AllTests.cpp
--- ../ice.orig/files/patch-cpp-test-Ice-metrics-AllTests.cpp	1970-01-01 01:00:00.000000000 +0100
+++ ./files/patch-cpp-test-Ice-metrics-AllTests.cpp	2013-05-20 04:20:07.000000000 +0200
@@ -0,0 +1,32 @@
+--- cpp.orig/test/Ice/metrics/AllTests.cpp	2013-03-11 15:19:47.000000000 +0000
++++ cpp/test/Ice/metrics/AllTests.cpp	2013-05-20 02:11:00.939194168 +0000
+@@ -597,9 +597,12 @@
+     testAttribute(clientMetrics, clientProps, update, "Connection", "incoming", "false");
+     testAttribute(clientMetrics, clientProps, update, "Connection", "adapterName", "");
+     testAttribute(clientMetrics, clientProps, update, "Connection", "connectionId", "Con1");
+-    testAttribute(clientMetrics, clientProps, update, "Connection", "localHost", "127.0.0.1");
++    if (!inFreeBSDJail())
++    {
++      testAttribute(clientMetrics, clientProps, update, "Connection", "localHost", "127.0.0.1");
++      testAttribute(clientMetrics, clientProps, update, "Connection", "remoteHost", "127.0.0.1");
++    }
+     //testAttribute(clientMetrics, clientProps, update, "Connection", "localPort", "");
+-    testAttribute(clientMetrics, clientProps, update, "Connection", "remoteHost", "127.0.0.1");
+     testAttribute(clientMetrics, clientProps, update, "Connection", "remotePort", "12010");
+     testAttribute(clientMetrics, clientProps, update, "Connection", "mcastHost", "");
+     testAttribute(clientMetrics, clientProps, update, "Connection", "mcastPort", "");
+@@ -814,9 +817,12 @@
+     testAttribute(serverMetrics, serverProps, update, "Dispatch", "incoming", "true", op);
+     testAttribute(serverMetrics, serverProps, update, "Dispatch", "adapterName", "TestAdapter", op);
+     testAttribute(serverMetrics, serverProps, update, "Dispatch", "connectionId", "", op);
+-    testAttribute(serverMetrics, serverProps, update, "Dispatch", "localHost", "127.0.0.1", op);
++    if (!inFreeBSDJail())
++    {
++      testAttribute(serverMetrics, serverProps, update, "Dispatch", "localHost", "127.0.0.1", op);
++      testAttribute(serverMetrics, serverProps, update, "Dispatch", "remoteHost", "127.0.0.1", op);
++    }
+     testAttribute(serverMetrics, serverProps, update, "Dispatch", "localPort", "12010", op);
+-    testAttribute(serverMetrics, serverProps, update, "Dispatch", "remoteHost", "127.0.0.1", op);
+     //testAttribute(serverMetrics, serverProps, update, "Dispatch", "remotePort", "12010", op);
+     testAttribute(serverMetrics, serverProps, update, "Dispatch", "mcastHost", "", op);
+     testAttribute(serverMetrics, serverProps, update, "Dispatch", "mcastPort", "", op);
diff -ruN --exclude=CVS ../ice.orig/files/patch-scripts-TestUtil.py ./files/patch-scripts-TestUtil.py
--- ../ice.orig/files/patch-scripts-TestUtil.py	2012-07-14 15:54:48.000000000 +0200
+++ ./files/patch-scripts-TestUtil.py	2013-05-21 02:45:33.000000000 +0200
@@ -1,6 +1,6 @@
---- scripts.orig/TestUtil.py	2011-06-15 21:44:00.000000000 +0200
-+++ scripts/TestUtil.py	2012-03-04 20:14:53.000000000 +0100
-@@ -74,6 +74,25 @@
+--- scripts.orig/TestUtil.py	2013-03-11 15:19:47.000000000 +0000
++++ scripts/TestUtil.py	2013-05-21 00:29:37.903194948 +0000
+@@ -84,6 +84,25 @@
  def isLinux():
      return sys.platform.startswith("linux")
  
@@ -26,19 +26,18 @@
  def getCppCompiler():
      compiler = ""
      if os.environ.get("CPP_COMPILER", "") != "":
-@@ -1590,7 +1609,15 @@
-             if isDarwin() and "nodarwin" in config:
-                 print "%s*** test not supported under Darwin%s" % (prefix, suffix)
+@@ -1846,6 +1865,14 @@
+                 print("%s*** test not supported under Darwin%s" % (prefix, suffix))
                  continue
-+
+ 
 +            if isFreeBSD() and "nofreebsd" in config:
-+                print "%s*** test not supported under FreeBSD%s" % (prefix, suffix)
++                print("%s*** test not supported under FreeBSD%s" % (prefix, suffix))
 +                continue
-             
++
 +            if isFreeBSDJail() and "nofreebsdjail" in config:
-+                print "%s*** test not supported within a FreeBSD Jail%s" % (prefix, suffix)
++                print("%s*** test not supported within a FreeBSD Jail%s" % (prefix, suffix))
 +                continue
 +
              if not isWin32() and "win32only" in config:
-                 print "%s*** test only supported under Win32%s" % (prefix, suffix)
+                 print("%s*** test only supported under Win32%s" % (prefix, suffix))
                  continue
diff -ruN --exclude=CVS ../ice.orig/pkg-message ./pkg-message
--- ../ice.orig/pkg-message	1970-01-01 01:00:00.000000000 +0100
+++ ./pkg-message	2013-05-20 18:43:50.000000000 +0200
@@ -0,0 +1,14 @@
+The default on-the-wire encoding for Ice changed in version 3.5 and IPv6
+is now enabled by default. ABI versions are not compatible.
+
+For details on these and additional changes please read the upgrading
+instructions available at
+
+	http://doc.zeroc.com/x/SQpN
+
+For on-the-wire background compatibility add
+
+	Ice.IPv6=0
+	Ice.Default.EncodingVersion=1.0
+
+to your Ice application configuration.
diff -ruN --exclude=CVS ../ice.orig/pkg-plist ./pkg-plist
--- ../ice.orig/pkg-plist	2012-07-14 15:54:48.000000000 +0200
+++ ./pkg-plist	2013-06-02 23:37:47.000000000 +0200
@@ -41,12 +41,14 @@
 include/Freeze/TransactionalEvictor.h
 include/Glacier2/Application.h
 include/Glacier2/Glacier2.h
+include/Glacier2/Metrics.h
 include/Glacier2/PermissionsVerifier.h
 include/Glacier2/PermissionsVerifierF.h
 include/Glacier2/Router.h
 include/Glacier2/RouterF.h
 include/Glacier2/SSLInfo.h
 include/Glacier2/Session.h
+include/Glacier2/SessionHelper.h
 include/Ice/Application.h
 include/Ice/BasicStream.h
 include/Ice/Buffer.h
@@ -77,6 +79,7 @@
 include/Ice/FacetMap.h
 include/Ice/FactoryTable.h
 include/Ice/FactoryTableInit.h
+include/Ice/Format.h
 include/Ice/Functional.h
 include/Ice/GCCountMap.h
 include/Ice/GCShared.h
@@ -91,6 +94,8 @@
 include/Ice/IncomingAsyncF.h
 include/Ice/Initialize.h
 include/Ice/InstanceF.h
+include/Ice/Instrumentation.h
+include/Ice/InstrumentationF.h
 include/Ice/LocalException.h
 include/Ice/LocalObject.h
 include/Ice/LocalObjectF.h
@@ -99,6 +104,10 @@
 include/Ice/Logger.h
 include/Ice/LoggerF.h
 include/Ice/LoggerUtil.h
+include/Ice/Metrics.h
+include/Ice/MetricsAdminI.h
+include/Ice/MetricsFunctional.h
+include/Ice/MetricsObserverI.h
 include/Ice/Object.h
 include/Ice/ObjectAdapter.h
 include/Ice/ObjectAdapterF.h
@@ -106,6 +115,8 @@
 include/Ice/ObjectF.h
 include/Ice/ObjectFactory.h
 include/Ice/ObjectFactoryF.h
+include/Ice/ObjectFactoryManagerF.h
+include/Ice/ObserverHelper.h
 include/Ice/Outgoing.h
 include/Ice/OutgoingAsync.h
 include/Ice/OutgoingAsyncF.h
@@ -114,6 +125,7 @@
 include/Ice/Process.h
 include/Ice/ProcessF.h
 include/Ice/Properties.h
+include/Ice/PropertiesAdmin.h
 include/Ice/PropertiesF.h
 include/Ice/Protocol.h
 include/Ice/ProtocolPluginFacade.h
@@ -132,13 +144,17 @@
 include/Ice/Service.h
 include/Ice/SliceChecksumDict.h
 include/Ice/SliceChecksums.h
+include/Ice/SlicedData.h
+include/Ice/SlicedDataF.h
 include/Ice/Stats.h
 include/Ice/StatsF.h
 include/Ice/Stream.h
 include/Ice/StreamF.h
+include/Ice/StreamHelpers.h
 include/Ice/StringConverter.h
 include/Ice/UndefSysMacros.h
 include/Ice/UserExceptionFactory.h
+include/Ice/Version.h
 include/IceBox/IceBox.h
 include/IceGrid/Admin.h
 include/IceGrid/Descriptor.h
@@ -160,6 +176,7 @@
 include/IceSSL/IceSSL.h
 include/IceSSL/Plugin.h
 include/IceStorm/IceStorm.h
+include/IceStorm/Metrics.h
 include/IceUtil/AbstractMutex.h
 include/IceUtil/ArgVector.h
 include/IceUtil/Cache.h
@@ -181,14 +198,15 @@
 include/IceUtil/MutexProtocol.h
 include/IceUtil/MutexPtrLock.h
 include/IceUtil/MutexPtrTryLock.h
+include/IceUtil/Optional.h
 include/IceUtil/Options.h
 include/IceUtil/OutputUtil.h
-include/IceUtil/RWRecMutex.h
 include/IceUtil/Random.h
 include/IceUtil/RecMutex.h
+include/IceUtil/ScannerConfig.h
 include/IceUtil/ScopedArray.h
 include/IceUtil/Shared.h
-include/IceUtil/StaticMutex.h
+include/IceUtil/StopWatch.h
 include/IceUtil/StringUtil.h
 include/IceUtil/Thread.h
 include/IceUtil/ThreadException.h
@@ -196,6 +214,7 @@
 include/IceUtil/Timer.h
 include/IceUtil/UUID.h
 include/IceUtil/Unicode.h
+include/IceUtil/UniquePtr.h
 include/IceXML/Parser.h
 include/Slice/CPlusPlusUtil.h
 include/Slice/Checksum.h
@@ -211,50 +230,50 @@
 include/Slice/Util.h
 lib/ImportKey.class
 lib/libFreeze.so
-lib/libFreeze.so.3.4.2
-lib/libFreeze.so.34
+lib/libFreeze.so.3.5.0
+lib/libFreeze.so.35
 lib/libGlacier2.so
-lib/libGlacier2.so.3.4.2
-lib/libGlacier2.so.34
+lib/libGlacier2.so.3.5.0
+lib/libGlacier2.so.35
 lib/libIce.so
-lib/libIce.so.3.4.2
-lib/libIce.so.34
+lib/libIce.so.3.5.0
+lib/libIce.so.35
 lib/libIceBox.so
-lib/libIceBox.so.3.4.2
-lib/libIceBox.so.34
+lib/libIceBox.so.3.5.0
+lib/libIceBox.so.35
 lib/libIceDB.so
-lib/libIceDB.so.3.4.2
-lib/libIceDB.so.34
+lib/libIceDB.so.3.5.0
+lib/libIceDB.so.35
 lib/libIceGrid.so
-lib/libIceGrid.so.3.4.2
-lib/libIceGrid.so.34
+lib/libIceGrid.so.3.5.0
+lib/libIceGrid.so.35
 lib/libIceGridFreezeDB.so
-lib/libIceGridFreezeDB.so.3.4.2
-lib/libIceGridFreezeDB.so.34
+lib/libIceGridFreezeDB.so.3.5.0
+lib/libIceGridFreezeDB.so.35
 lib/libIcePatch2.so
-lib/libIcePatch2.so.3.4.2
-lib/libIcePatch2.so.34
+lib/libIcePatch2.so.3.5.0
+lib/libIcePatch2.so.35
 lib/libIceSSL.so
-lib/libIceSSL.so.3.4.2
-lib/libIceSSL.so.34
+lib/libIceSSL.so.3.5.0
+lib/libIceSSL.so.35
 lib/libIceStorm.so
-lib/libIceStorm.so.3.4.2
-lib/libIceStorm.so.34
+lib/libIceStorm.so.3.5.0
+lib/libIceStorm.so.35
 lib/libIceStormFreezeDB.so
-lib/libIceStormFreezeDB.so.3.4.2
-lib/libIceStormFreezeDB.so.34
+lib/libIceStormFreezeDB.so.3.5.0
+lib/libIceStormFreezeDB.so.35
 lib/libIceStormService.so
-lib/libIceStormService.so.3.4.2
-lib/libIceStormService.so.34
+lib/libIceStormService.so.3.5.0
+lib/libIceStormService.so.35
 lib/libIceUtil.so
-lib/libIceUtil.so.3.4.2
-lib/libIceUtil.so.34
+lib/libIceUtil.so.3.5.0
+lib/libIceUtil.so.35
 lib/libIceXML.so
-lib/libIceXML.so.3.4.2
-lib/libIceXML.so.34
+lib/libIceXML.so.3.5.0
+lib/libIceXML.so.35
 lib/libSlice.so
-lib/libSlice.so.3.4.2
-lib/libSlice.so.34
+lib/libSlice.so.3.5.0
+lib/libSlice.so.35
 %%DATADIR%%/Freeze/BackgroundSaveEvictor.ice
 %%DATADIR%%/Freeze/CatalogData.ice
 %%DATADIR%%/Freeze/Connection.ice
@@ -266,6 +285,7 @@
 %%DATADIR%%/Freeze/Exception.ice
 %%DATADIR%%/Freeze/Transaction.ice
 %%DATADIR%%/Freeze/TransactionalEvictor.ice
+%%DATADIR%%/Glacier2/Metrics.ice
 %%DATADIR%%/Glacier2/PermissionsVerifier.ice
 %%DATADIR%%/Glacier2/PermissionsVerifierF.ice
 %%DATADIR%%/Glacier2/Router.ice
@@ -286,11 +306,14 @@
 %%DATADIR%%/Ice/Identity.ice
 %%DATADIR%%/Ice/ImplicitContext.ice
 %%DATADIR%%/Ice/ImplicitContextF.ice
+%%DATADIR%%/Ice/Instrumentation.ice
+%%DATADIR%%/Ice/InstrumentationF.ice
 %%DATADIR%%/Ice/LocalException.ice
 %%DATADIR%%/Ice/Locator.ice
 %%DATADIR%%/Ice/LocatorF.ice
 %%DATADIR%%/Ice/Logger.ice
 %%DATADIR%%/Ice/LoggerF.ice
+%%DATADIR%%/Ice/Metrics.ice
 %%DATADIR%%/Ice/ObjectAdapter.ice
 %%DATADIR%%/Ice/ObjectAdapterF.ice
 %%DATADIR%%/Ice/ObjectFactory.ice
@@ -308,6 +331,7 @@
 %%DATADIR%%/Ice/SliceChecksumDict.ice
 %%DATADIR%%/Ice/Stats.ice
 %%DATADIR%%/Ice/StatsF.ice
+%%DATADIR%%/Ice/Version.ice
 %%DATADIR%%/IceBox/IceBox.ice
 %%DATADIR%%/IceGrid/Admin.ice
 %%DATADIR%%/IceGrid/Descriptor.ice
@@ -324,13 +348,16 @@
 %%DATADIR%%/IceSSL/ConnectionInfo.ice
 %%DATADIR%%/IceSSL/EndpointInfo.ice
 %%DATADIR%%/IceStorm/IceStorm.ice
+%%DATADIR%%/IceStorm/Metrics.ice
 %%DATADIR%%/LICENSE
 %%DATADIR%%/config/convertssl.py
 %%DATADIR%%/config/icegrid-slice.3.1.ice.gz
 %%DATADIR%%/config/icegrid-slice.3.2.ice.gz
 %%DATADIR%%/config/icegrid-slice.3.3.ice.gz
+%%DATADIR%%/config/icegrid-slice.3.5.ice.gz
 %%DATADIR%%/config/templates.xml
-%%DATADIR%%/config/upgradeicegrid.py
+%%DATADIR%%/config/upgradeicegrid33.py
+%%DATADIR%%/config/upgradeicegrid35.py
 %%PORTDOCS%%%%DOCSDIR%%/reference/Freeze.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Freeze/BackgroundSaveEvictor.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Freeze/CatalogData.html
@@ -351,7 +378,6 @@
 %%PORTDOCS%%%%DOCSDIR%%/reference/Freeze/TransactionAlreadyInProgressException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Freeze/TransactionalEvictor.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Glacier2.html
-%%PORTDOCS%%%%DOCSDIR%%/reference/Glacier2/Admin.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Glacier2/CannotCreateSessionException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Glacier2/IdentitySet.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Glacier2/PermissionDeniedException.html
@@ -389,6 +415,7 @@
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/DNSException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/DatagramLimitException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/EncapsulationException.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/Ice/EncodingVersion.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/Endpoint.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/EndpointInfo.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/EndpointParseException.html
@@ -407,6 +434,7 @@
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/IllegalMessageSizeException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/ImplicitContext.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/InitializationException.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/Ice/Instrumentation.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/InvalidReplicaGroupIdException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/Locator.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/LocatorRegistry.html
@@ -432,6 +460,7 @@
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/Properties.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/PropertiesAdmin.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/ProtocolException.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/Ice/ProtocolVersion.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/ProxyParseException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/ProxyUnmarshalException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/RequestFailedException.html
@@ -461,6 +490,7 @@
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/UnsupportedEncodingException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/UnsupportedProtocolException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/Ice/VersionMismatchException.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/Ice/VersionParseException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IceBox.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IceBox/AlreadyStartedException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IceBox/AlreadyStoppedException.html
@@ -545,8 +575,20 @@
 %%PORTDOCS%%%%DOCSDIR%%/reference/IceGrid/TemplateDescriptor.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IceGrid/UserAccountMapper.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IceGrid/UserAccountNotFoundException.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/ConnectionMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/DispatchMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/InvocationMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/Metrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/MetricsAdmin.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/MetricsFailures.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/RemoteMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/SessionMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/SubscriberMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/ThreadMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/TopicMetrics.html
+%%PORTDOCS%%%%DOCSDIR%%/reference/IceMX/UnknownMetricsView.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IcePatch2.html
-%%PORTDOCS%%%%DOCSDIR%%/reference/IcePatch2/Admin.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IcePatch2/FileAccessException.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IcePatch2/FileInfo.html
 %%PORTDOCS%%%%DOCSDIR%%/reference/IcePatch2/FileServer.html
@@ -589,6 +631,7 @@
 %%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/IceStorm
 %%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/IceSSL
 %%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/IcePatch2
+%%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/IceMX
 %%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/IceGrid
 %%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/IceBox
 %%PORTDOCS%%@dirrm %%DOCSDIR%%/reference/Ice
